class Constraint implements IUIComponentConstraint {
  public get movable(): boolean {
    return true;
  }

  public get removable(): boolean {
    return true;
  }

  public get copyable(): boolean {
    return true;
  }

  public get extremity(): boolean {
    return true;
  }

  public acceptableParent(): boolean {
    return true;
  }

  public acceptableChild(): boolean {
    return false;
  }
}

type PropertyDefinition = {
  variable: UniquePropertyDefinitionType;
  action: UniquePropertyDefinitionType;
};

const uniquePropertyDefinition: IUniquePropertyDefinition & PropertyDefinition = {
  variable: {
    displayName: 'variable',
    definition: {
      required: true,
      rerender: true,
      acceptStatic: false,
      deepObserve: true,
    },
    type: 'string',
  },
  action: {
    displayName: 'action',
    definition: {
      required: true,
      rerender: true,
      acceptDynamic: false,
      candidate: [{displayName: '', value: ''}],
    },
    type: 'action',
    value: '',
  },
};

export class CookBook250440VariableObserver implements IUIElementCore {
  private _oldVariable: IArgument;
  public get wrapperClass(): UIElementWrapperClass {
    return 'SimpleUIElement';
  }

  public get elementTypeName(): string {
    return CookBook250440VariableObserver.name;
  }

  public get displayType(): UIElementDisplayType {
    return 'FUNCTIONAL';
  }

  public get constraintClass(): UIComponentConstraintClass {
    return Constraint;
  }

  public get uniquePropertyDefinition(): IUniquePropertyDefinition {
    return uniquePropertyDefinition;
  }

  public get commonPropertyDefinition(): ICommonPropertyDefinition {
    return {};
  }

  public get dependElements(): UIElementCoreClass[] {
    return [];
  }


  public createElement(
    container: IUIContainer,
    properties: IUIElementPropertyAccessor<PropertyDefinition & ICommonPropertyDefinition>
  ): IHTMLElementBuilder {
    const builder = window.imHichee.HTMLElementBuilder.createElement('span', HTMLSpanElement);
    if (container.designMode) {
      const name = window.imHichee.MessageBuilder.get('CAP.Z.IWP.HICHEE.COMPONENT.NAME.CookBook250440VariableObserver');
      builder.setText(name).setCSS('border', '1px dotted #333');
    }
    return builder;
  }

  public updateElement(
    builder: IHTMLElementBuilder,
    container: IUIContainer,
    properties: IUIElementPropertyAccessor<PropertyDefinition & ICommonPropertyDefinition>
  ): void {
    return;
  }

  public destroyElement(
    builder: IHTMLElementBuilder,
    container: IUIContainer,
    properties: IUIElementPropertyAccessor<IUniquePropertyDefinition & ICommonPropertyDefinition>
  ): void {
    return;
  }

  public createChildren(self: IUIElement, container: IUIContainer): IUIElement[] {
    return [];
  }

  public updateChildren(
    children: IUIElement[],
    self: IUIElement,
    container: IUIContainer,
    properties: IUIElementPropertyAccessor<IUniquePropertyDefinition & ICommonPropertyDefinition>
  ): IUIElement[] {
    if (container.designMode) return children;

    const variable = properties.getProperty('variable');

    if (variable.equals(this._oldVariable)) return children;
    this._oldVariable = variable.clone();

    const chart = container.eventCharts.getChart(properties.getProperty('action').toString());
    if (!chart) return children;

    const context = container.eventCharts.createContext(chart, null);
    chart.run(context, self);

    return children;
  }

  public clonedChildren(
    children: IUIElement[],
    self: IUIElement,
    container: IUIContainer,
    properties: IUIElementPropertyAccessor<IUniquePropertyDefinition & ICommonPropertyDefinition>
  ): IUIElement[] {
    if (container.designMode) return children;

    const variable = properties.getProperty('variable');
    this._oldVariable = variable.clone();

    return children;
  }
}
